//      test
//      ------------------------------------------------------------------------

// #define pts_test

#ifdef	pts_test

void massage (int min, int max, int cycles)
{
    set < pts > sp;
    pts tp[2];
    pts *ptp;
    int c = 0, m = 0, mi;
    string mis;

    set < pts >::iterator i;

    strstream stp0;
    string tp0, tp1;

    sp.insert (pts ());

    while (c++ < cycles)
    {
	if (sp.size () < max && rand () > RAND_MAX / 2)
	{
	    ptp = tp;
	    ptp = random_sample_n (sp.begin (), sp.end (), ptp, 1);
	    assert (ptp == tp + 1);
//                      cout << c << "f " << tp[0] <<  " " << endl;
	    strstream stp0;

	    stp0 << tp[0];
	    cout << "-" << stp0.str () << endl;	// debug
	    sp.erase (tp[0]);
//                      cout << ".";
	    tp[1] = tp[0].fork ();
	    sp.insert (tp[0]);
//                      cout << ".";
	    sp.insert (tp[1]);
//                      cout << ".";
//                      for(i = sp.begin(); i != sp.end(); i++)
//                              cout << *i;
//                      cout << endl;
	}
	if (sp.size () > min && rand () < RAND_MAX / 4)
	{
	    ptp = tp;
	    ptp = random_sample_n (sp.begin (), sp.end (), ptp, 2);
	    assert (ptp == tp + 2);
//                      cout << c << "j " << tp[0] << tp[1] << " " << endl;
	    strstream stp0;

	    stp0 << tp[0];
	    tp0 = stp0.str ();
	    cout << "-" << tp0 << endl;	// debug
	    sp.erase (tp[0]);
//                      cout << ".";
	    sp.erase (tp[1]);
//                      cout << ".";
	    tp[0].join (tp[1]);
	    sp.insert (tp[0]);
//                      cout << ".";
//                      for(i = sp.begin(); i != sp.end(); i++)
//                              cout << *i;
//                      cout << endl;
	}
	if (rand () < RAND_MAX / 2)
	{
	    ptp = tp;
	    ptp = random_sample_n (sp.begin (), sp.end (), ptp, 1);
	    assert (ptp == tp + 1);
	    sp.erase (tp[0]);
	    tp[0].set_dirty ();
	    sp.insert (tp[0]);
	}

	mi = 100000;
	for (i = sp.begin (); i != sp.end (); i++)
	{
	    strstream s;

	    s << *i;
	    if (strlen (s.str ()) < mi)
	    {
		mi = strlen (s.str ());
		mis = s.str ();
	    }
	    if (strlen (s.str ()) > m)
	    {
		m = strlen (s.str ());
		cout << "At run " << c << " max is now " << m << " with "
		  << sp.size () << " elements and current minimum " << mi <<
		  " :" << mis << s.str () << endl;
	    }
	}
    }
}

int main ()
{
    pts t1, t2, t3, t4, t5, t6, t7, t8, t9;


    // example that shows forks after joins
    t2 = t1.fork ();
    cout << t1.equivalent (t2) << endl;
    t1.set_dirty ();
    cout << t1.equivalent (t2) << endl;
    cout << t1 << t2 << endl;
    t3 = t1.fork ();
    cout << t1 << t2 << t3 << endl;
    t4 = t2.fork ();
    cout << t1 << t2 << t3 << t4 << endl;
    cout << t1 << " join " << t4 << " -> ";
    t1.join (t4);
    cout << t1 << "\n";
    t4 = t1.fork ();
    cout << t1 << t2 << t3 << t4 << endl;
    cout << t2 << " join " << t3 << " -> ";
    t2.join (t3);
    cout << t2 << "\n";
    t3 = t2.fork ();
    cout << t1 << t2 << t3 << t4 << endl;
    t1.set_dirty ();
    t4.set_dirty ();
    cout << t1 << " join " << t2 << " -> ";
    t1.join (t2);
    cout << t1 << "\n";
    cout << t3 << " join " << t4 << " -> ";
    t3.join (t4);
    cout << t3 << "\n";
    cout << t1 << t3 << endl;
    cout << t1 << " join " << t3 << " -> ";
    t9 = t3;
    t1.join (t3);
    cout << t1 << "\n";
    cout << t1 << endl;

//      massage(10,100,10000);  

    // Xtl  

//      t2=t1.fork();

    char buf[1000];
    mem_buffer mb (buf, 1000);

    GIOP_format < mem_buffer > gfmb (mb);
    obj_output < GIOP_format < mem_buffer > >os (gfmb);

//   os.simple(l1);
//      os.simple(cch);
    cout << t9 << endl;
    os.simple (t9);

//   *(char*)mb.require(1)=0;
    cout << mb.size () << endl;

    Bytef ubuf[1000];
    Bytef cbuf[2000];
    unsigned long csize = 2000;
    int cres;

    memcpy (ubuf, mb.data (), mb.size ());
    cres = compress (cbuf, &csize, ubuf, mb.size ());
    assert (cres == Z_OK);
    cout << csize << endl;


    mem_buffer mb2 (buf, mb.size ());

    GIOP_format < mem_buffer > gfmb2 (mb2);
    obj_input < GIOP_format < mem_buffer > >is (gfmb2);

    pts tt;

//      is.simple(cch); 
    is.simple (tt);

    cout << tt << endl;



    /*      
       // example that leads to ff transform based reduces
       t2=t1.fork();
       t1.set_dirty();
       t3=t1.fork();
       cout << t3 << endl;

       t4=t3.fork();
       t4.set_dirty();
       cout << t4 << endl;
       t5=t3.fork();
       t3.set_dirty();
       cout << t3 << endl;
       cout << t3 << " join " << t4 << " -> ";
       t3.join(t4);
       cout << t3 << "\n";
     */


    /*
       // example that leads to simple reduces and ff/sf reduces
       t2=t1.fork();
       t1.set_dirty();
       t3=t1.fork();
       cout << t3 << endl;

       t4=t3.fork();
       t4.set_dirty();
       t4.set_dirty();

       t5=t3.fork();
       cout << t3 << " join " << t4 << " -> ";
       t3.join(t4);
       cout << t3 << "\n";

       cout << t3 << " join " << t5 << " -> ";
       t3.join(t5);
       cout << t3 << "\n";
     */


    /*
       // basic example
       t2 = t1.fork();
       t2.set_dirty();
       cout << t1.dominates(t2) << "\n";
       t3 = t2.fork();
       t3.set_dirty();

       cout << t1 << " join " << t3 << " -> ";
       t1.join(t3);
       cout << t1 << "\n";

       t1.set_dirty();
       cout << t1 << " join " << t2 << " -> ";
       t1.join(t2);
       cout << t1 << "\n";
     */

    return 0;
}

#endif
